Zephir Runtime
==============

Zephir - Ze(nd Engine) Ph(p) I(nt)r(mediate) - is a high-level language that can be plugged-in into the Zend Engine.
Code is compiled on-the-fly using a JIT compiler (LLVM).

Main features:

* Both dynamic/static typing
* Reduced execution overhead compared with full interpretation
* Restricted procedural programming, promoting OOP
* Memory safety
* Just-In-Time (JIT) compiler

Compiler design goals:

* Multi-pass compilation
* Type speculation/inference
* Allow runtime profile-guided optimizations, pseudo-constant propagation and indirect/virtual function inlining

Documentation & Blog
--------------------
* A preliminary documentation can be found [here](http://zephir-lang.com/)
* Official Blog can be found [here](http://blog.zephir-lang.com/)
* Sublime/TextMate highlight-syntax bundle [here](http://github.com/phalcon/zephir-sublime)

License
-------
Zephir is open-sourced software licensed under the MIT License. See the LICENSE file for more information.

Contributing
------------
[See `CONTRIBUTING.md`](https://github.com/phalcon/zephir/blob/master/CONTRIBUTING.md) for details about contributions to this repository.
